$! From: Scott Allendorf 319/335-1960 <allendorf@IowaSP.Physics.UIowa.Edu>
$! Subject: News 6.0-3
$!
$! Locking and the database files
$!
$! I have a scheme which seems to cover all the bases for locking the database
$! files in a cluster.  The DCL code is at the end of this message.  Do with
$! it what you will.  The general idea is to use sysman to set the logical
$! cluster-wide.  Once this is done, running unlocker will cause the batch job
$! to pause until everyone lets go of the database files (Hopefully, noone
$! spawned out of news or invoked an editor from news and walked away for the
$! weekend).  The normal convert/fdl  stuff is then protected via the logical
$! until it is finished.  Use sysman to deassign the logical and news is off to
$! the races again.  Hasn't failed yet (except the time someone was composing a
$! reply in the editor and went to Austrailia for a week...).
$!
$!
$!-----------------------------------------------------------------------------
$! Convert the News database files to optimize their structure.
$!-----------------------------------------------------------------------------
$ Do_Convert_DB:
$!
$ WS "Optimizing News database..."
$ Set Proc /Privilege = All
$ Mcr SysMan
Set Env /Cluster
Do Define /System /Exec News_Stop "Converting database."
$ WS "Waiting for all news processes to stop..."
$ Run News_Exe:UnLocker
$ On Error Then GoTo Drop_Out
$!
$ Analyze /RMS /FDL /Output = News_Root:NewsGroups.FDL
News_Root:News.Groups
$ Edit /FDL /NoInteractive /Analyze = News_Root:NewsGroups.FDL -
                                      News_Root:NewsGroups.FDL
$ Convert /FDL = News_Root:NewsGroups.FDL News_Root:News.Groups -
                                          News_Root:News.Groups
$ Purge News_Root:News.Groups
$ Purge News_Root:NewsGroups.FDL
$ Set File /Global_Buffer = 10 News_Root:News.Groups
$!
$ Analyze /RMS /FDL /Output = News_Root:NewsItems.FDL News_Root:News.Items
$ Edit /FDL /NoInteractive /Analyze = News_Root:NewsItems.FDL -
                                      News_Root:NewsItems.FDL
$ Convert /FDL = News_Root:NewsItems.FDL News_Root:News.Items -
                                         News_Root:News.Items
$ Purge News_Root:News.Items
$ Purge News_Root:NewsItems.FDL
$ Set File /Global_Buffer = 50 News_Root:News.Items
$!
$ Analyze /RMS /FDL /Output = News_Root:History.FDL News_Root:History.v60
$ Edit /FDL /NoInteractive /Analyze = News_Root:History.FDL -
                                      News_Root:History.FDL
$ Convert /FDL = News_Root:History.FDL News_Root:History.v60 -
                                       News_Root:History.v60
$ Purge News_Root:History.v60
$ Purge News_Root:History.FDL
$ Set File /Global_Buffer = 25 News_Root:History.v60
$!
$ Mcr SysMan
Set Env /Cluster
Do Deassign /System /Exec News_Stop
$!
$ On Error Then GoTo Abort
$ Return
$!
$ Drop_Out:
$!
$ On Error Then GoTo Abort
$!
$ Mail Sys$Input MYNODE::NEWSGURU /Subject = -
"Automatic NewsSkim alarm: CONVERT_DB FAILED (''F$Time( )')"
The NewsSkim job failed to convert the database - please investigate.

              Have a nice day,

              The News Administrator
$!
$ ReSubmit = 0
$ Return
